<?php
/**
 *------------------------------------------------------------------------------
 *  iCagenda v3 by Jooml!C - Events Management Extension for Joomla! 2.5 / 3.x
 *------------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright   Copyright (c)2012-2014 Cyril Rezé, Jooml!C - All rights reserved
 *
 * @license     GNU General Public License version 3 or later; see LICENSE.txt
 * @author      Cyril Rezé (Lyr!C)
 * @link        http://www.joomlic.com
 *
 * @version 	3.4.0 2014-12-20
 * @since       1.0
 *------------------------------------------------------------------------------
*/

// No direct access to this file
defined('_JEXEC') or die();

?>
<!--
 * - - - - - - - - - - - - - -
 * iCagenda 3.4.0 by Jooml!C
 * - - - - - - - - - - - - - -
 * @copyright	Copyright (c)2012-2014 JOOMLIC - All rights reserved.
 *
-->
<?php

// Get Application
$app = JFactory::getApplication();

$iCModeliChelper = new iCModeliChelper();

$icsetvar = 'components/com_icagenda/add/elements/icsetvar.php';

$navposition = $this->navposition;
$datesDisplay_menu = $this->datesDisplay;
$datesDisplay_global = $this->datesDisplay_global;

$datesDisplay = $datesDisplay_menu ? $datesDisplay_menu : $datesDisplay_global;

$orderby = $this->orderby;
$dis_catDesc = $this->display_catDesc;
$catDesc_opts = $this->catDesc_opts;
$CatDesc_global = $this->CatDesc_global;
$CatDesc_global_opts = $this->CatDesc_global_opts;
$pagination = $this->pagination;

if ($dis_catDesc == 'global')
{
	$display_catDesc = $CatDesc_global;
	$cat_opts = $CatDesc_global_opts;
}
else
{
	$display_catDesc = $dis_catDesc;
	$cat_opts = $catDesc_opts;
}

if (!is_array($cat_opts)) $cat_opts = array();

// Header
?>
<div id="icagenda<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
	<?php if ($this->params->get('show_page_heading', 1)) : ?>
	<h1 class="componentheading">
	<?php echo $this->escape($this->params->get('page_heading')); ?>
	</h1>
	<?php endif; ?>

	<?php
	if(isset($this->data)) $stamp = $this->data;
	$stampitems = $stamp->items;
	$someObjectArr = (array)$stampitems;
	$control = empty($someObjectArr);

	$alldates_array = array();

	if($stampitems)
	{
		foreach ($stampitems AS $event)
		{
			$eventid = $event->id;
			$allDates = $event->AllDatesDisplay;
			for($i = 0; $i < count($allDates); $i++)
			{
				$date_evtid = $allDates[$i].'_'.$eventid;
				array_push($alldates_array, $date_evtid);
			}
		}
	}

	if ($orderby == 2)
	{
		sort($alldates_array);
	}
	else
	{
		rsort($alldates_array);
	}

	$count_all_dates = count($alldates_array);

	$count_all_events = $iCModeliChelper->count_Events();

	$getpage=JRequest::getVar('page', 1);

	$number_per_page = $this->number;
	$arrowtext = $this->arrowtext;

	$document	= JFactory::getDocument();

	$tpl_template_events	= JPATH_SITE . '/components/com_icagenda/themes/packs/'.$this->template.'/'.$this->template.'_events.php';
	$tpl_template_list		= JPATH_SITE . '/components/com_icagenda/themes/packs/'.$this->template.'/'.$this->template.'_list.php';
	$tpl_default_events		= JPATH_SITE . '/components/com_icagenda/themes/packs/'.$this->template.'/'.$this->template.'_events.php';
	$tpl_component_css		= JPATH_SITE . '/components/com_icagenda/themes/packs/'.$this->template.'/css/'.$this->template.'_component.css';


	// Setting component css file to load
	if ( file_exists($tpl_component_css) )
	{
		$css_component	= '/components/com_icagenda/themes/packs/'.$this->template.'/css/'.$this->template.'_component.css';
		$css_com_rtl	= '/components/com_icagenda/themes/packs/'.$this->template.'/css/'.$this->template.'_component-rtl.css';
	}
	else
	{
		$css_component	= '/components/com_icagenda/themes/packs/default/css/default_component.css';
		$css_com_rtl	= '/components/com_icagenda/themes/packs/default/css/default_component-rtl.css';
	}

	// New file to display all dates for each events
	if ( file_exists($tpl_template_events) )
	{
		$tpl_events		= $tpl_template_events;
	}
	elseif ( (!$this->template OR $this->template != 'default')
		AND file_exists($tpl_template_list)
		AND $datesDisplay == 1 )
	{
		$msg = 'iCagenda '.JText::_('PHPMAILER_FILE_ACCESS').' <strong>'.$this->template.'_events.php</strong>';
		$app->enqueueMessage($msg, 'warning');
		$tpl_events		= JPATH_SITE . '/components/com_icagenda/themes/packs/default/default_events.php';
		$css_component	= '/components/com_icagenda/themes/packs/default/css/default_component.css';
	}
	elseif ( (!$this->template OR $this->template != 'default')
		AND $datesDisplay != 1 )
	{
		$tpl_events		= $tpl_template_events;
	}
	else
	{
		$msg = 'iCagenda '.JText::_('PHPMAILER_FILE_OPEN').' <strong>'.$this->template.'_events.php</strong>';
		$app->enqueueMessage($msg, 'warning');
		return false;
	}

	// If theme pack is not having YOUR_THEME_events.php file, loading YOUR_THEME_list.php file to display list of events
	if ( file_exists($tpl_template_list)
		AND !file_exists($tpl_template_events) )
	{
		$tpl_list		= $tpl_template_list;
	}
	else
	{
		$tpl_list		= JPATH_SITE . '/components/com_icagenda/themes/packs/default/default_events.php';
	}

	// Add the media specific CSS to the document
	JLoader::register('iCagendaMediaCss', JPATH_ROOT . '/components/com_icagenda/helpers/media_css.class.php');
	iCagendaMediaCss::addMediaCss($this->template, 'component');

//	if ($stamp->container->header)
//	{
		echo '<div class="ic-clearfix">';
//		echo $stamp->container->header;

		if ($datesDisplay == '1')
		{
			echo $iCModeliChelper->subtitle($count_all_dates, $getpage, $arrowtext, $number_per_page, $pagination);
		}
		else
		{
			echo $iCModeliChelper->subtitle($count_all_events, $getpage, $arrowtext, $number_per_page, $pagination);
		}

		if (in_array($navposition, array('0', '2')))
		{
			if (($datesDisplay == '1')
				AND (file_exists( $tpl_events )))
			{
				if (($count_all_dates / $number_per_page) > 1)
				{
					echo $iCModeliChelper->pagination($count_all_dates, $getpage, $arrowtext, $number_per_page, $pagination);
				}
			}
			else
			{
				if (($count_all_events / $number_per_page) > 1)
				{
					echo $iCModeliChelper->pagination($count_all_events, $getpage, $arrowtext, $number_per_page, $pagination);
				}
			}
		}

		$catid_array = array();
		$catinfos_array = array();

		if ($stampitems AND $display_catDesc)
		{
			foreach ($stampitems AS $event)
			{
				$cat_id = $event->cat_id;
				$cat_title = $event->cat_title;
				$cat_color = $event->cat_color;
				if ($event->cat_desc)
				{
					$cat_desc = $event->cat_desc;
				}
				else
				{
					$cat_desc = ' ';
				}
				$fontColor = $event->fontColor;

				array_push($catid_array, $cat_id);

				$array = array($cat_title, $cat_color, $cat_desc, $fontColor);
				$comma_separated = implode("::", $array);
				if (!in_array($comma_separated, $catinfos_array))
				{
					array_push($catinfos_array, $comma_separated);
				}
			}
		}
		$cat_result = array_unique($catid_array);

		for($i = 0; $i < count($catinfos_array); $i++)
		{
			$cat_getinfos = explode('::', $catinfos_array[$i]);

			if (in_array('1', $cat_opts))
			{
				echo '<div class="cat_header_title ' . $cat_getinfos['3'] . ' ic-clearfix" style="background: ' . $cat_getinfos['1'] . ';">' . $cat_getinfos['0'] . '</div>';
			}
			elseif (in_array('2', $cat_opts))
			{
				echo '<div class="cat_header_desc ic-clearfix">' . $cat_getinfos['2'] . '</div>';
			}
		}

		echo '</div>';
//	}


	$mainframe = JFactory::getApplication();
	$isSef = $mainframe->getCfg( 'sef' );

	if (!$control)
	{
		if (file_exists($tpl_events) AND $datesDisplay == 1)
		{
			//---------------------------
			// All Dates - List View
			//---------------------------

			// Set number of events to be displayed per page
			$index = $number_per_page * ($getpage - 1);
			$recordsToBeDisplayed = array_slice($alldates_array, $index, $number_per_page, true);

			// Do for each dates to be displayed on this list of events, depending of menu and/or global options
			for ($i = 0; $i < count($alldates_array); $i++)
			{
				// Get id and date for each date to be displayed
				$evt_date_id = $alldates_array[$i];
				$ex_alldates_array = explode('_', $evt_date_id);
				$evt = $ex_alldates_array['0'];
				$evt_id = $ex_alldates_array['1'];

				if (in_array($evt_date_id, $recordsToBeDisplayed))
				{
					foreach ($stamp->items as $item)
					{
						if ($evt_id == $item->id)
						{
							$evtDates = $item->AllDatesDisplay;
							$idevt = '';

							if (in_array($evt, $evtDates))
							{
								// Load Event Data
								$EVENT_DATE			= $iCModeliChelper->nextDate($evt, $item);
								$EVENT_SET_DATE		= $iCModeliChelper->EventUrlDate($evt);
								$EVENT_DAY			= $this->day_display_global ? $iCModeliChelper->day($evt) : false;
								$EVENT_MONTHSHORT	= $this->month_display_global ? $iCModeliChelper->monthShortJoomla($evt) : false;
								$EVENT_YEAR			= $this->year_display_global ? $iCModeliChelper->year($evt) : false;
								$READ_MORE			= ($this->shortdesc_display_global == '' && !$item->shortdesc) ? $iCModeliChelper->readMore($item->url, $item->desc, '[&#46;&#46;&#46;]') : false;
								// Load Events List/Event Details common Data variables
								require $icsetvar;

								// Load Template to display Event
								require $tpl_events;
							}
						}
					}
				}
			}
			echo '<div>';

			// List Bottom

			// AddThis buttons
			if ($this->atlist && isset($item))
			{
				echo '<div class="share">' . $item->share . '</div><div style="clear:both"></div>';
			}

			// List Bottom - Navigation & pagination
			if ($navposition == '1' OR $navposition == '2')
			{
				if (($count_all_dates / $number_per_page) > 1)
				{
					echo $iCModeliChelper->pagination($count_all_dates, $getpage, $arrowtext, $number_per_page, $pagination);
				}
			}

			echo '</div>';
			echo '<div style="clear:both">&nbsp;</div>';
		}
		else
		{
			//---------------------------
			// Next/Last Date - List View
			//---------------------------

			if (file_exists($tpl_events))
			{
				foreach ($stamp->items as $item)
				{
					// Load Event Data
					$EVENT_DATE			= $item->nextDate;
					$EVENT_DAY			= $this->day_display_global ? $item->day : false;
					$EVENT_MONTHSHORT	= $this->month_display_global ? $item->monthShortJoomla : false;
					$EVENT_YEAR			= $this->year_display_global ? $item->year : false;
					$READ_MORE			= ($this->shortdesc_display_global == '' && !$item->shortdesc) ? $iCModeliChelper->readMore($item->url, $item->desc, '[&#46;&#46;&#46;]') : false;

					// Load Events List/Event Details common Data
					require $icsetvar;

					// Load Template to display Event
					require $tpl_events;
				}
			}
			else
			{
				require $tpl_list;
			}

			// List Bottom
			echo '<div>';

			if (file_exists($tpl_events))
			{
				// AddThis buttons
				if ($this->atlist && isset($item->share))
				{
					echo '<div class="share">' . $item->share . '</div><div style="clear:both"></div>';
				}
			}

			// List Bottom - Navigation & pagination
			if ($navposition == '1' OR $navposition == '2')
			{
				if (($count_all_events / $number_per_page) > 1)
				{
					echo $iCModeliChelper->pagination($count_all_events, $getpage, $arrowtext, $number_per_page, $pagination);
				}
			}

			echo '</div>';
			echo '<div style="clear:both">&nbsp;</div>';
		}
	}

	$this->dispatcher->trigger('onListAfterDisplay', array('com_icagenda.list', &$item, &$this->params));
	?>
</div>

<?php
$document->addStyleSheet( JURI::base( true ) . '/components/com_icagenda/add/css/style.css' );
$document->addStyleSheet( JURI::base( true ) . '/media/com_icagenda/icicons/style.css' );
$document->addStyleSheet( JURI::base( true ) . '/media/com_icagenda/css/tipTip.css' );

// Theme pack component css
$document->addStyleSheet( JURI::base( true ) . $css_component );

// RTL css if site language is RTL
$lang = JFactory::getLanguage();

if ( $lang->isRTL()
	&& file_exists( JPATH_SITE . $css_com_rtl) )
{
	$document->addStyleSheet( JURI::base( true ) . $css_com_rtl );
}

if(version_compare(JVERSION, '3.0', 'lt'))
{
	JHTML::_('behavior.mootools');

	// load jQuery, if not loaded before (NEW VERSION IN 1.2.6)
	$scripts = array_keys($document->_scripts);
	$scriptFound = false;

	for ($i = 0; $i < count($scripts); $i++)
	{
		if (stripos($scripts[$i], 'jquery.min.js') !== false)
		{
			$scriptFound = true;
		}
		// load jQuery, if not loaded before as jquery - added in 1.2.7
		if (stripos($scripts[$i], 'jquery.js') !== false)
		{
			$scriptFound = true;
		}
	}

	// jQuery Library Loader
	if (!$scriptFound)
	{
		// load jQuery, if not loaded before
		if (!JFactory::getApplication()->get('jquery'))
		{
			JFactory::getApplication()->set('jquery', true);
			// add jQuery
			$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js');
			$document->addScript( JURI::base( true ) . '/components/com_icagenda/js/jquery.noconflict.js');
		}
	}
}
else
{
	JHtml::_('bootstrap.framework');
	JHtml::_('jquery.framework');
}

// Loading Script tipTip used for iCtips
JHtml::script( 'com_icagenda/jquery.tipTip.js', false, true );

// Add RSS Feeds
$menu = $app->getMenu()->getActive()->id;

$feed = 'index.php?option=com_icagenda&amp;view=list&amp;Itemid=' . (int) $menu . '&amp;format=feed';
$rss = array(
	'type'    =>  'application/rss+xml',
	'title'   =>   'RSS 2.0');

$document->addHeadLink(JRoute::_($feed.'&amp;type=rss'), 'alternate', 'rel', $rss);
