<?php
/**
 *------------------------------------------------------------------------------
 *  iCagenda v3 by Jooml!C - Events Management Extension for Joomla! 2.5 / 3.x
 *------------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright   Copyright (c)2012-2014 Cyril Rezé, Jooml!C - All rights reserved
 *
 * @license     GNU General Public License version 3 or later; see LICENSE.txt
 * @author      Cyril Rezé (Lyr!C)
 * @link        http://www.joomlic.com
 *
 * @version     3.4.0 2014-10-11
 * @since       1.0
 *------------------------------------------------------------------------------
*/

// No direct access to this file
defined('_JEXEC') or die();

jimport('joomla.application.component.helper');

// iCagenda Class control (Joomla 2.5/3.x)
if(!class_exists('iCJView')) {
   if(version_compare(JVERSION,'3.0.0','ge')) {
      class iCJView extends JViewLegacy {};
   } else {
      jimport('joomla.application.component.view');
      class iCJView extends JView {};
   }
}

/**
 * HTML View class - iCagenda.
 */
class icagendaViewList extends iCJView
{
	// TODO: check and remove
	protected $return_page;

	/**
	 * Execute and display a template script.
	 *
	 * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
	 *
	 * @return  mixed  A string if successful, otherwise a Error object.
	 */
	public function display($tpl = null)
	{
		$app			= JFactory::getApplication();
		$document		= JFactory::getDocument();
		$this->params	= $app->getParams();

		// loading data
		$this->data = $this->get('Data');

		$iCparams	= $this->params;

		// Menu Options
		$this->atlist			= $iCparams->get('atlist');
		$this->template			= $iCparams->get('template');
		$this->title			= $iCparams->get('title');
		$this->display_catDesc	= $iCparams->get('displayCatDesc_menu', '');
		$this->catDesc_opts		= $iCparams->get('displayCatDesc_checkbox', '');
		$this->number			= $iCparams->get('number', '5');
		$this->datesDisplay		= $iCparams->get('datesDisplay', '');
		$this->orderby			= $iCparams->get('orderby', '2');

		// Component Options
		$this->iconPrint_global			= $iCparams->get('iconPrint_global', 0);
		$this->iconAddToCal_global		= $iCparams->get('iconAddToCal_global', 0);
		$this->iconAddToCal_options		= $iCparams->get('iconAddToCal_options', 0);
		$this->copy						= $iCparams->get('copy');
		$this->navposition				= $iCparams->get('navposition', 1);
		$this->arrowtext				= $iCparams->get('arrowtext', 1);
		$this->GoogleMaps				= $iCparams->get('GoogleMaps', 1);
		$this->CatDesc_global			= $iCparams->get('CatDesc_global', '0');
		$this->CatDesc_global_opts		= $iCparams->get('CatDesc_checkbox', '');
		$this->datesDisplay_global		= $iCparams->get('datesDisplay_global', 2);
		$this->pagination				= $iCparams->get('pagination', 1);
		$this->day_display_global		= $iCparams->get('day_display_global', 1);
		$this->month_display_global		= $iCparams->get('month_display_global', 1);
		$this->year_display_global		= $iCparams->get('year_display_global', 1);
		$this->venue_display_global		= $iCparams->get('venue_display_global', 1);
		$this->city_display_global		= $iCparams->get('city_display_global', 1);
		$this->country_display_global	= $iCparams->get('country_display_global', 1);
		$this->shortdesc_display_global	= $iCparams->get('shortdesc_display_global', '');
		$this->statutReg				= $iCparams->get('statutReg', 0);

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$vcal = $app->input->get('vcal');

		if ($vcal)
		{
			$tpl = 'vcal';
		}

		// Process the content plugins.
		JPluginHelper::importPlugin('content');

		if (version_compare(JVERSION, '3.0', 'ge')) // J3
		{
			$this->dispatcher	= JEventDispatcher::getInstance();
		}
		else // J2.5
		{
			$this->dispatcher	= JDispatcher::getInstance();
		}

		$this->_prepareDocument();

		parent::display($tpl);

		icagendaEvents::isListOfEvents();
	}

	/**
	 * Prepares the document
	 */
	protected function _prepareDocument()
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu();
		$pathway 	= $app->getPathway();
		$title 		= null;

		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		$title = $this->params->get('page_title', '');

		if (empty($title))
		{
			$title = $app->getCfg('sitename');
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
		}

		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description', ''))
		{
			$this->document->setDescription($this->params->get('menu-meta_description', ''));
		}

		if ($this->params->get('menu-meta_keywords', ''))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords', ''));
		}

		if ($app->getCfg('MetaTitle') == '1' && $this->params->get('menupage_title', ''))
		{
			$this->document->setMetaData('title', $this->params->get('page_title', ''));
		}
	}
}
